﻿﻿<?php
class osC_Payment_paystar extends osC_Payment
{
	var $_title, $_code = 'paystar', $_status = false, $_sort_order, $_order_id;

	function osC_Payment_paystar()
	{
		require(dirname(__FILE__) . '/../../../paystarconfig.php');
		global $osC_Database, $osC_Language, $osC_ShoppingCart;
		$this->paystarwsconfig = $ws_config;
		$this->_title = $osC_Language->get('payment_paystar_title') . ' ' . $this->paystarwsconfig['name'];
		$this->_method_title = $osC_Language->get('payment_paystar_method_title') . ' ' . $this->paystarwsconfig['name'];
		$this->_status = (MODULE_PAYMENT_PAYSTAR_STATUS == '1') ? true : false;
		$this->_sort_order = MODULE_PAYMENT_PAYSTAR_SORT_ORDER;

		if ($this->_status === true)
		{
			if ((int) MODULE_PAYMENT_PAYSTAR_ORDER_STATUS_ID > 0)
				$this->order_status = MODULE_PAYMENT_PAYSTAR_ORDER_STATUS_ID;
		}

		if ((int) MODULE_PAYMENT_PAYSTAR_ZONE > 0)
		{
			$check_flag = false;

			$Qcheck = $osC_Database->query('select zone_id from :table_zones_to_geo_zones where geo_zone_id = :geo_zone_id and zone_country_id = :zone_country_id order by zone_id');
			$Qcheck->bindTable(':table_zones_to_geo_zones', TABLE_ZONES_TO_GEO_ZONES);
			$Qcheck->bindInt(':geo_zone_id', MODULE_PAYMENT_PAYSTAR_ZONE);
			$Qcheck->bindInt(':zone_country_id', $osC_ShoppingCart->getBillingAddress('country_id'));
			$Qcheck->execute();

			while ($Qcheck->next())
			{
				if ($Qcheck->valueInt('zone_id') < 1)
				{
					$check_flag = true;
					break;
				}
				elseif ($Qcheck->valueInt('zone_id') == $osC_ShoppingCart->getBillingAddress('zone_id'))
				{
					$check_flag = true;
					break;
				}
			}

			if ($check_flag === false)
				$this->_status = false;
		}
	}

	function selection()
	{
		return array('id' => $this->_code, 'module' => $this->_method_title);
	}

	function confirmation()
	{
		$this->_order_id = osC_Order::insert(ORDERS_STATUS_PREPARING);
	}

	function process_button()
	{
		global $osC_Currencies, $osC_ShoppingCart, $osC_Language, $osC_Database;
		$currency = (MODULE_PAYMENT_PAYSTAR_CURRENCY == 'Selected Currency') ? $osC_Currencies->getCode() : MODULE_PAYMENT_PAYSTAR_CURRENCY;
		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);
		$order = $this->_order_id;
		
		$c = $osC_ShoppingCart->getBillingAddress();
		$description = "شناسه سفارش : {$order}";
		$description .= "\nشناسه کاربری خریدار : {$c['id']}";
		$description .= "\nنام و نام خانوادگی خریدار : {$c['firstname']} {$c['lastname']}";
		if(!empty($c['telephone_number']))
			$description .= "\nتلفن خریدار : {$c['telephone_number']}";
		
		$res = false;
		try
		{
			$f = array(
				'amount' => $amount/10,
				'pin' => MODULE_PAYMENT_PAYSTAR_PIN,
				'callback' => osc_href_link(FILENAME_CHECKOUT, 'process', 'SSL', null, null, true),
				'bank' => MODULE_PAYMENT_PAYSTAR_BANK,
				'description' => $description
			);

			$f_ = '';
			foreach($f as $k=>$v) 
				$f_ .= $k . '=' . urlencode($v) . '&'; 
				
			rtrim($f_, '&');

			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL, "https://{$this->paystarwsconfig['address']}/api/create/");
			curl_setopt($ch,CURLOPT_POST, count($f));
			curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
			$res = curl_exec($ch);
			curl_close($ch);
		}
		catch(Exception $e) 
		{
			$res = false;
		}		
		
		if(empty($res))
		{
			osC_Order::remove($this->_order_id);
			echo $osC_Language->get('payment_paystar_result_error_1').'<br>';			
		}
		else if(strlen($res) > 5)
		{
			$osC_Database->simpleQuery("insert into `" . DB_TABLE_PREFIX . "paystar_transactions` (orders_id,receipt_id,transaction_method,transaction_date,transaction_amount,transaction_id) values ('$order','$res','paystar','','$amount','')");
			echo '<div style="text-align:left;">' . osc_link_object(osc_href_link('https://' . $this->paystarwsconfig['address'] . '/paying/' . $res, '', '', '', false), osc_draw_image_button('button_confirm_order.gif', $osC_Language->get('button_confirm_order'), 'id="btnConfirmOrder"')) . '</div><div style="display:none">';
		}
		else
		{
			osC_Order::remove($this->_order_id);
			echo $osC_Language->get('payment_paystar_result_error_2') . $res . '</div><br>';
		}	

		//return $process_button_string;
	}


	function get_error()
	{
		global $osC_Language;
		return $error;
	}
		
	function process()
	{
		global $osC_Language, $osC_Customer, $osC_Currencies, $osC_ShoppingCart, $_POST, $_GET, $messageStack, $osC_Database;
		$this->_order_id = osC_Order::insert(ORDERS_STATUS_PREPARING);
		$order = $this->_order_id;						

		$currency = (MODULE_PAYMENT_PAYSTAR_CURRENCY == 'Selected Currency') ? $osC_Currencies->getCode() : MODULE_PAYMENT_PAYSTAR_CURRENCY;

		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);

		$au = !empty($_POST['transid']) ? $_POST['transid'] : false;
		if($au)
		{
			$res = false;
			try
			{
				$f = array(
					'amount' => $amount/10,
					'pin' => MODULE_PAYMENT_PAYSTAR_PIN,
					'transid' => $au
				);
				
				$f_ = '';
				foreach($f as $k=>$v) 
					$f_ .= $k . '=' . urlencode($v) . '&'; 
					
				rtrim($f_, '&');

				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL, "https://{$this->paystarwsconfig['address']}/api/verify/");
				curl_setopt($ch,CURLOPT_POST, count($f));
				curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
				curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
			}
			catch(Exception $e) 
			{
				$res = false;
			}

			if(empty($res))
			{
				//  delete receipt id from database
				$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "paystar_transactions` where 1 and ( receipt_id = '$au' ) and ( orders_id = '$order' )");
				//
				osC_Order :: remove($this->_order_id);
				$messageStack->add_session('checkout', $osC_Language->get('payment_paystar_result_error_3'), 'error');

				osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));			
			}
			else if($res == 1)
			{
				// this is a succcessfull payment
				// we update our DataBase
				//	echo "PAYSTAR Response is : " . $resultStr;					//show resultStr in payment page
				//  save transaction_id to database
				$osC_Database->simpleQuery("update `" . DB_TABLE_PREFIX . "paystar_transactions` set transaction_id = '$au',transaction_date = '" . date("YmdHis") . "' where 1 and ( receipt_id = '$au' )");
				//
				$Qtransaction = $osC_Database->query('insert into :table_orders_transactions_history (orders_id, transaction_code, transaction_return_value, transaction_return_status, date_added) values (:orders_id, :transaction_code, :transaction_return_value, :transaction_return_status, now())');
				$Qtransaction->bindTable(':table_orders_transactions_history', TABLE_ORDERS_TRANSACTIONS_HISTORY);
				$Qtransaction->bindInt(':orders_id', $order);
				$Qtransaction->bindInt(':transaction_code', 1);
				$Qtransaction->bindValue(':transaction_return_value', $au);
				$Qtransaction->bindInt(':transaction_return_status', 1);
				$Qtransaction->execute();
				//
				$this->_order_id = osC_Order :: insert();
												
				$comments = $osC_Language->get('payment_paystar_method_refid').'[' . $au . ']';

				osC_Order :: process($this->_order_id, $this->order_status,$comments);				
			}				
			else
			{
				//  delete receipt id from database
				$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "paystar_transactions` where 1 and ( receipt_id = '$au' ) and ( orders_id = '$order' )");
				//
				osC_Order :: remove($this->_order_id);
				$messageStack->add_session('checkout', $osC_Language->get('payment_paystar_result_error_2')  . $res . '</div>', 'error');

				osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));				
			}
		}
		else
		{
			//  delete receipt id from database
			$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "paystar_transactions` where 1 and ( orders_id = '$order' )");
			//
			// this is a UNsucccessfull payment
			osC_Order :: remove($this->_order_id);

			$messageStack->add_session('checkout', $osC_Language->get('payment_paystar_result_error'), 'error');

			osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
		}
	}

	function callback()
	{
		global $osC_Database;
		//
	}	
}
?>